export namespace MeterbusLibUtils {
    export function bcd(data : number[]) : number {
        let v : string = ""
        data.forEach((c : number) => {
            v += (c & 0xf0) >> 4
            v += c & 0x0f
        })
        let r : number = parseInt(v)
        return r
    }

    export function manufCode(data : number[]) : string {
        let v : number = (data[1] << 8) + data[0]
        return String.fromCharCode((((v >> 10) & 0x1f) + 64), (((v >> 5) & 0x1f) + 64), ((v & 0x1f) + 64))
    }

    export function jsonPrepaper(obj:any, hideKeys:string[]) : any {
        let dup = {}
        for (let key in obj) {
            if ((hideKeys.indexOf(key) == -1) && ! ((key[0] == "_") && (key[1] == "_"))) {
                let dkey = (key[0] == "_") ? key.slice(1) : key
                dup[dkey] = obj[key]
            }
        }
        return dup
    }

    export function clone(obj:any) : any {
        let dup = {}
        for (let key in obj) {
            dup[key] = obj[key]
        }
        return dup
    }

}

